﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Linq;
using HeuristicLab.Services.Hive.Common.ServiceContracts;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using HeuristicLab.Clients.Hive.Slave.Tests;
using HeuristicLab.Clients.Hive.Jobs;
using HeuristicLab.Algorithms.GeneticAlgorithm;
using HeuristicLab.Problems.TestFunctions;
using HeuristicLab.Optimization;
using HeuristicLab.Core;
using System.Threading;
using HeuristicLab.PluginInfrastructure.Manager;
using System.IO;
using System.Reflection;

namespace HeuristicLab.Clients.Hive.Tests {
  [TestClass]
  public class ExperimentManagerTests {


    [ClassInitialize]
    public static void MyClassInitialize(TestContext testContext) {
      //PluginLoader.pluginAssemblies.Any();
      ServiceLocator.Instance = new MockServiceLocator();
    }
    
    [TestMethod]
    public void TestExperimentUpload() {
      HiveExperimentClient hec = new HiveExperimentClient();
      var optimizer = CreateOptimizer();
      hec.HiveJob = new HiveJob(optimizer);

      hec.Start();

      while (hec.ExecutionState != ExecutionState.Stopped) {
        Thread.Sleep(500);
      }

    }

    private IOptimizer CreateOptimizer() {
      var ga = new GeneticAlgorithm();
      ga.Engine = new SequentialEngine.SequentialEngine();
      ga.Problem = new SingleObjectiveTestFunctionProblem();
      return ga;
    }

  }
}
